## csound 6.10.0~dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

project(Csound)

ENABLE_TESTING()

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
set(CMAKE_COMPILER_IS_CLANG 1)
endif()

message(STATUS "${CMAKE_HOME_DIRECTORY}")

if(NOT MSVC AND NOT WASM)
set(CMAKE_CXX_FLAGS_RELEASE "-O3 ")
set(CMAKE_C_FLAGS_RELEASE "-O3 ")
endif()

# Project definitions
set(APIVERSION "6.0")

# Relative install paths
set(EXECUTABLE_INSTALL_DIR "bin")

set(LOCALE_INSTALL_DIR "share/locale")
set(HEADER_INSTALL_DIR "include/csound")

set(CS_FRAMEWORK_DEST "~/Library/Frameworks")
include(TestBigEndian)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckIncludeFileCXX)
include(CheckLibraryExists)
include(CMakeParseArguments)
include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Utility to munge with items in a list.
#
macro(LIST_REPLACE LIST INDEX NEWVALUE)
    list(INSERT ${LIST} ${INDEX} ${NEWVALUE})
    MATH(EXPR __INDEX "${INDEX} + 1")
    list (REMOVE_AT ${LIST} ${__INDEX})
endmacro(LIST_REPLACE)

# Utility function to make executables. All plugin targets should use this as it
# sets up output directory set in top-level CmakeLists.txt
# and adds an appropriate install target
#
# name - name of executable to produce
# srcs - list of src files
# libs - list of library files to link to
# output_name (OPTIONAL) - overide the name of the generated executable
#
function(make_executable name srcs libs)
    add_executable(${name} ${srcs})
    target_link_libraries (${name} ${libs})
    set_target_properties(${name} PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${BUILD_BIN_DIR})

    if(${ARGC} EQUAL 4)
        set_target_properties(${name} PROPERTIES
            OUTPUT_NAME ${ARGV3})
    endif()
    install(TARGETS ${name}
	RUNTIME DESTINATION "${EXECUTABLE_INSTALL_DIR}" )
endfunction(make_executable)


# Utility function to make a utility executable
#
# name - name of executable to produce
# srcs - list of src files

function(make_utility name srcs)
    make_executable(${name} "${srcs}" "${CSOUNDLIB}")
    add_dependencies(${name} ${CSOUNDLIB})

    if(LINUX)
        target_link_libraries(${name} m)
    endif()
endfunction()

# Checks if dependencies for an enabled target are fulfilled.
# If FAIL_MISSING is true and the dependencies are not fulfilled,
# it will abort the cmake run.
# If FAIL_MISSING is false, it will set the option to OFF.
# If the target is not enabled, it will do nothing.
# example: check_deps(BUILD_NEW_PARSER FLEX_EXECUTABLE BISON_EXECUTABLE)
function(check_deps option)
    if(${option})
        set(i 1)
        while( ${i} LESS ${ARGC} )
            set(dep ${ARGV${i}})
            if(NOT ${dep})
                if(FAIL_MISSING)
                    message(FATAL_ERROR
                        "${option} is enabled, but ${dep}=\"${${dep}}\"")
                else()
                    message(STATUS "${dep}=\"${${dep}}\", so disabling ${option}")
                    set(${option} OFF PARENT_SCOPE)
                    # Set it in the local scope too
                    set(${option} OFF)
                endif()
            endif()
            math(EXPR i "${i}+1")
        endwhile()
    endif()
    if(${option})
        message(STATUS "${option} is enabled.")
    else()
        message(STATUS "${option} is disabled.")
    endif()
endfunction(check_deps)

### COMPILER OPTIMIZATION FLAGS
option(USE_COMPILER_OPTIMIZATIONS "Use the default Csound compiler optimization flags" ON)
if(USE_COMPILER_OPTIMIZATIONS)
include(cmake/CompilerOptimizations.cmake)
endif()

if(APPLE)
    set(OSX_VERSION " ")
endif()

## USER OPTIONS ##
# Optional targets, they should all default to ON (check_deps will disable them if not possible to build)
option(USE_DOUBLE "Set to use double-precision floating point for audio samples." ON)
option(BUILD_UTILITIES "Build stand-alone executables for utilities that can also be used with -U" ON)
option(NEW_PARSER_DEBUG "Enable tracing of new parser" OFF)
option(BUILD_MULTI_CORE "Enable building for multicore system (requires BUILD_NEW_PARSER)" ON)
option(FAIL_MISSING "Fail when a required external dependency is not present (useful for packagers)" OFF)
option(USE_GETTEXT "Use the Gettext internationalization library" ON)
option(BUILD_STATIC_LIBRARY "Also build a static version of the csound library" OFF)
option(USE_LRINT "Use lrint/lrintf for converting floating point values to integers." ON)
option(USE_CURL "Use CURL library" ON)
option(BUILD_RELEASE "Build for release" ON)
option(BUILD_INSTALLER "Build installer" OFF)
option(BUILD_TESTS "Build tests" ON)
option(USE_GIT_COMMIT "Show the git commit in version information" ON)
option(REQUIRE_PTHREADS "For non-Windows systems, set whether Csound will use threads or not" ON)

# Include this after the install path definitions so we can override them here.
# Also after function definitions so we can use them there
# Also after user options so that the default values don't overwrite the custom files values
find_file(CUSTOM_CMAKE "Custom.cmake" HINTS ${CMAKE_HOME_DIRECTORY})
if(CUSTOM_CMAKE)
    message(STATUS "Including Custom.cmake file: ${CUSTOM_CMAKE}")
    include(${CUSTOM_CMAKE})
else()
    message(STATUS "Not using Custom.cmake file.")
endif()

option(USE_LIB64 "Set to on to set installation directory for libraries to lib64" OFF)
if(USE_LIB64)
    set(LIBRARY_INSTALL_DIR "lib64")
    add_definitions("-DLIB64")
else()
    set(LIBRARY_INSTALL_DIR "lib")
endif()
message(STATUS "LIBRARY INSTALL DIR: ${LIBRARY_INSTALL_DIR}")

if(USE_DOUBLE)
   message(STATUS "Building with 64-bit floats")
    set(PLUGIN_INSTALL_DIR "${LIBRARY_INSTALL_DIR}/csound/plugins64-${APIVERSION}")
else()
  message(STATUS "Building with 32-bit floats")
    set(PLUGIN_INSTALL_DIR "${LIBRARY_INSTALL_DIR}/csound/plugins-${APIVERSION}")
endif()

execute_process (
     COMMAND python -c
     "import site, sys; sys.stdout.write(site.getusersitepackages())"
     OUTPUT_VARIABLE PYTHON_USER_SITE_PACKAGES
   )

SET(PYTHON_MODULE_INSTALL_DIR ${PYTHON_USER_SITE_PACKAGES} CACHE PATH "Python module install dir")

set(JAVA_MODULE_INSTALL_DIR ${LIBRARY_INSTALL_DIR} CACHE PATH "Java module install dir")
set(LUA_MODULE_INSTALL_DIR ${LIBRARY_INSTALL_DIR} CACHE PATH "Lua module install dir")

# VL this is breaking CUDA compilation. It's not necessary
#if(APPLE)
#    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11 -stdlib=libc++")
#endif()

if(WIN32 AND NOT MSVC)
    if(EXISTS "C:/MinGW/include")
        include_directories(C:/MinGW/include)
    else()
        MESSAGE(STATUS "MinGW include dir not found.")
    endif()

    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--add-stdcall-alias")
endif()

if(MSVC)
  include_directories(${PROJECT_SOURCE_DIR}/msvc/include)
  list(APPEND CMAKE_REQUIRED_INCLUDES "${PROJECT_SOURCE_DIR}/msvc/include;${PROJECT_SOURCE_DIR}/msvc/deps/include")
endif()

if(WIN32)
    set(CMAKE_SHARED_LIBRARY_PREFIX "")
    set(CMAKE_SHARED_MODULE_PREFIX "")


if(NOT MSVC)
    set(CSOUND_WINDOWS_LIBRARIES
        msvcrt
        advapi32
        comctl32
        comdlg32
        glu32
        kernel32
        odbc32
        odbccp32
        ole32
        oleaut32
        shell32
        user32
        uuid
        winmm
        winspool
        ws2_32
        wsock32
        advapi32
        comctl32
        comdlg32
        glu32
        msvcrt
        kernel32
        odbc32
        odbccp32
        ole32
        oleaut32
        shell32
        user32
        uuid
        winmm
        winspool
        ws2_32
        wsock32)
else()
    if(MSVC_VERSION LESS 1900)
    set(CSOUND_WINDOWS_LIBRARIES
        msvcrt
        advapi32
        comctl32
        comdlg32
        glu32
        kernel32
        odbc32
        odbccp32
        ole32
        oleaut32
        shell32
        user32
        uuid
        winmm
        winspool
        ws2_32
        wsock32
        advapi32
        comctl32
        comdlg32
        glu32
        msvcrt
        kernel32
        odbc32
        odbccp32
        ole32
        oleaut32
        shell32
        user32
        uuid
        winmm
        winspool
        ws2_32
        wsock32)
    else()
    set(CSOUND_WINDOWS_LIBRARIES
        ucrt
        vcruntime
        advapi32
        comctl32
        comdlg32
        glu32
        kernel32
        mincore
        odbc32
        odbccp32
        ole32
        oleaut32
        shell32
        user32
        uuid
        winmm
        winspool
        ws2_32
        wsock32
        advapi32
        comctl32
        comdlg32
        glu32
        kernel32
        odbc32
        odbccp32
        ole32
        oleaut32
        shell32
        user32
        uuid
        winmm
        winspool
        ws2_32
        wsock32)
    endif()
endif()

if(MSVC)
  # Experimented with flags but did not make change performance results
  #set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /Oi /fp:fast /arch:AVX2")
  #set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Oi /fp:fast /arch:AVX2")
  #set(CompilerFlags
  #  CMAKE_CXX_FLAGS
  #  CMAKE_CXX_FLAGS_DEBUG
  #  CMAKE_CXX_FLAGS_RELEASE
  #  CMAKE_C_FLAGS
  #  CMAKE_C_FLAGS_DEBUG
  #  CMAKE_C_FLAGS_RELEASE
  #  )
  #foreach(CompilerFlag ${CompilerFlags})
  #  string(REPLACE "/MD" "/MT" ${CompilerFlag} "${${CompilerFlag}}")
  #endforeach()
else()
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mstackrealign -static-libgcc -static")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mstackrealign -static-libstdc++ -static-libgcc -static")
  set_target_properties(${CSOUNDLIB} PROPERTIES LINK_FLAGS "-static-libstdc++ -static-libgcc -static")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -static-libstdc++ -static-libgcc -static")
endif()

endif(WIN32)

if(APPLE)
set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -stdlib=libc++")
set_target_properties(${CSOUNDLIB} PROPERTIES CXX_COMPILE_FLAGS  "-std=c++11")
endif()

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    set(LINUX YES)
else()
    set(LINUX NO)
endif()

set(BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR})

check_c_compiler_flag(-fvisibility=hidden HAS_VISIBILITY_HIDDEN)
check_cxx_compiler_flag(-fvisibility=hidden HAS_CXX_VISIBILITY_HIDDEN)
if (HAS_VISIBILITY_HIDDEN)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
endif()
if (HAS_CXX_VISIBILITY_HIDDEN)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
endif()

check_c_compiler_flag(-std=gnu99 HAS_GNU99)
if (HAS_GNU99)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
endif()
if (HAS_CXX_VISIBILITY_HIDDEN)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
endif()

if(APPLE)
if(IOS)
message(STATUS "Building for iOS.")
else()
message(STATUS "Building for OSX")
  if(BUILD_INSTALLER)
    set(CS_FRAMEWORK_DEST "${CMAKE_INSTALL_PREFIX}")
  endif()

  set(DEFAULT_OSX_SYSROOT /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.8.sdk/)

  if(NOT CMAKE_OSX_SYSROOT AND EXISTS ${DEFAULT_OSX_SYSROOT})
    set(CMAKE_OSX_SYSROOT ${DEFAULT_OSX_SYSROOT})
  endif()

  if(CMAKE_OSX_SYSROOT AND NOT CMAKE_OSX_SYSROOT MATCHES ".*OSX10.6.*")
    set(CMAKE_OSX_DEPLOYMENT_TARGET 10.7)
    message(STATUS "OSX: Setting Deployment Target to 10.7")
  endif()

  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DHAVE_VECLIB")

  if(NOT VECLIB_PATH)
    set(VECLIB_PATH "/System/Library/Frameworks/")
  endif()
 endif()

endif()

if(USE_DOUBLE)
    if(APPLE)
        set(CSOUNDLIB "CsoundLib64")
        set(PLUGIN_INSTALL_DIR "${CS_FRAMEWORK_DEST}/${CSOUNDLIB}.framework/Versions/${APIVERSION}/Resources/Opcodes64")
    else()
        set(CSOUNDLIB "csound64")
    endif()
else()
    if(APPLE)
        set(CSOUNDLIB "CsoundLib")
        set(PLUGIN_INSTALL_DIR "${CS_FRAMEWORK_DEST}/${CSOUNDLIB}.framework/Versions/${APIVERSION}/Resources/Opcodes")
    else()
        set(CSOUNDLIB "csound")
    endif()
endif()

if(APPLE)
    if(BUILD_INSTALLER)

=== InOut/CMakeLists.txt ===
# REAL TIME AUDIO AND MIDI

message(STATUS "")
message(STATUS "## REALTIME AUDIO AND MIDI ##")

option(USE_PULSEAUDIO "Build the PulseAudio I/O module" ON)
option(USE_PORTAUDIO "Build the PortAudio I/O module" ON)
option(USE_PORTMIDI "Build the PortMIDI I/O module" ON)
option(USE_IPMIDI "Build the IPMIDI I/O module" ON)
option(USE_JACK "Build the jack I/O module and opcodes" ON)
option(USE_ALSA "Build the ALSA I/O module" ON)
# option(USE_COREAUDIO "Build the CoreAudio I/O module" ON)
option(USE_COREMIDI "Build the CoreMIDI I/O Module" ON)
option(USE_AUDIOUNIT "Build the CoreAudio AudioUnit I/O module (requires CoreAudio)" ON)
option(USE_FLTK "Use FLTK for graphs and widget opcodes" ON)
option(BUILD_VIRTUAL_KEYBOARD "Build Virtual MIDI keyboard" ON)
option(NEED_PORTTIME "porttime library separate from portmidi" ON)

set(CMAKE_REQUIRED_INCLUDES /usr/local/include)

# FIND LIBRARIES AND HEADERS

if(USE_ALSA)
    find_library(ALSA_LIBRARY asound)
    check_include_file(alsa/asoundlib.h ALSA_HEADER)
endif()
if(USE_PORTAUDIO)
    find_path(PORTAUDIO_INCLUDE_PATH portaudio.h)
    find_library(PORTAUDIO_LIBRARY NAMES portaudio portaudio_x64)

    if(PORTAUDIO_INCLUDE_PATH AND PORTAUDIO_LIBRARY)
        try_run(PORTAUDIO_V19 PORTAUDIO_TEST_COMPILED
            ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../cmake/portaudio_test.c
            CMAKE_FLAGS -DLINK_LIBRARIES:STRING=${PORTAUDIO_LIBRARY}
            COMPILE_DEFINITIONS "-I${PORTAUDIO_INCLUDE_PATH}"
            COMPILE_OUTPUT_VARIABLE OUTPUT)
        if(NOT PORTAUDIO_TEST_COMPILED AND NOT WIN32)
            set(PORTAUDIO_V19 false)
        endif()
    else()
        set(PORTAUDIO_V19 false)
    endif()
endif()
if(USE_PORTMIDI)
    find_path(PORTMIDI_INCLUDE_PATH portmidi.h)
    find_library(PORTMIDI_LIBRARY portmidi)
    if(NOT WIN32)
        if(NEED_PORTTIME)
            find_library(PORTTIME_LIBRARY porttime)
        endif()
    endif()
endif()
if(USE_JACK)
    find_library(JACK_LIBRARY jack)
    find_library(JACKDMP_LIBRARY jackdmp)
    check_include_file(jack/jack.h JACK_HEADER)
endif()
if(USE_PULSEAUDIO)
    find_library(PULSEAUDIO_LIBRARY pulse)
    find_library(PULSESIMPLE_LIBRARY pulse-simple)
    check_include_file(pulse/simple.h PULSEAUDIO_HEADER)
endif()
# if(USE_COREAUDIO)
#    find_path(COREAUDIO_INCLUDE_PATH CoreAudio.h)
#    find_library(COREAUDIO_LIBRARY CoreAudio)
# endif()
if(USE_COREMIDI)
    find_path(COREMIDI_INCLUDE_PATH CoreMidi.h)
    find_library(COREMIDI_LIBRARY CoreMidi)
    find_library(COREFOUNDATION_LIBRARY CoreFoundation)
endif()
if(USE_AUDIOUNIT)
    find_path(AUDIOUNIT_INCLUDE_PATH AudioUnit.h)
    find_library(AUDIOUNIT_LIBRARY AudioUnit)
    find_library(COREFOUNDATION_LIBRARY CoreFoundation)
    find_path(COREAUDIO_INCLUDE_PATH CoreAudio.h)
    find_library(COREAUDIO_LIBRARY CoreAudio)
endif()

# BUILD TARGETS

# check_deps(USE_COREAUDIO APPLE COREAUDIO_INCLUDE_PATH COREAUDIO_LIBRARY)
# if(USE_COREAUDIO)
#    make_plugin(rtcoreaudio rtcoreaudio.c)
#    target_include_directories(rtcoreaudio PRIVATE ${COREAUDIO_INCLUDE_PATH})
#    target_link_libraries(rtcoreaudio ${COREAUDIO_LIBRARY})
# endif()

check_deps(USE_COREMIDI APPLE COREMIDI_INCLUDE_PATH COREMIDI_LIBRARY COREFOUNDATION_LIBRARY)
if(USE_COREMIDI)
    make_plugin(cmidi cmidi.c)
    target_include_directories(cmidi PRIVATE ${COREMIDI_INCLUDE_PATH})
    target_link_libraries(cmidi ${COREMIDI_LIBRARY} ${COREFOUNDATION_LIBRARY})
endif()

check_deps(USE_AUDIOUNIT APPLE COREAUDIO_INCLUDE_PATH COREAUDIO_LIBRARY AUDIOUNIT_INCLUDE_PATH AUDIOUNIT_LIBRARY COREFOUNDATION_LIBRARY)
if(USE_AUDIOUNIT)
    make_plugin(rtauhal rtauhal.c)
    target_include_directories(rtauhal PRIVATE ${AUDIOUNIT_INCLUDE_PATH})
    target_link_libraries(rtauhal ${AUDIOUNIT_LIBRARY} ${COREFOUNDATION_LIBRARY} ${COREAUDIO_LIBRARY})
endif()

check_deps(USE_ALSA ALSA_HEADER ALSA_LIBRARY PTHREAD_LIBRARY)
if(USE_ALSA)
    set(rtalsa_LIBS
        ${ALSA_LIBRARY} ${PTHREAD_LIBRARY} m)
    make_plugin(rtalsa rtalsa.c ${rtalsa_LIBS})
endif()

if(WIN32)
    message(STATUS "Building Windows MME plugin(rtwinmm).")
    if(MSVC)
      make_plugin(rtwinmm rtwinmm.c)
      target_link_libraries(rtwinmm winmm.lib)
      target_link_libraries(rtwinmm gdi32)
      target_link_libraries(rtwinmm kernel32)
    else()
      set(rtwinmm_LIBS
          winmm gdi32 kernel32) # should probably do checks for these libs
      make_plugin(rtwinmm rtwinmm.c "${rtwinmm_LIBS}")
    endif()
endif()


check_deps(USE_PULSEAUDIO PULSEAUDIO_HEADER PULSEAUDIO_LIBRARY PULSESIMPLE_LIBRARY)
if(USE_PULSEAUDIO)
    make_plugin(rtpulse rtpulse.c ${PULSEAUDIO_LIBRARY} ${PULSESIMPLE_LIBRARY})
endif()

if(WIN32)
    check_deps(USE_PORTAUDIO PORTAUDIO_INCLUDE_PATH PORTAUDIO_LIBRARY)
else()
    check_deps(USE_PORTAUDIO PORTAUDIO_INCLUDE_PATH PORTAUDIO_LIBRARY PORTAUDIO_TEST_COMPILED)
endif()
if(USE_PORTAUDIO AND PORTAUDIO_V19 MATCHES 1)
    message(STATUS "Building rtpa module.")
    make_plugin(rtpa rtpa.c)
    target_include_directories(rtpa PRIVATE ${PORTAUDIO_INCLUDE_PATH})
    if(BUILD_STATIC_LIBRARY)
        if(WIN32)
            set_source_files_properties(rtpa.c PROPERTIES LANGUAGE CXX)
            target_link_libraries(rtpa winmm dsound setupapi ${PORTAUDIO_LIBRARY} ${CSOUND_WINDOWS_LIBRARIES})
        else()
            target_link_libraries(rtpa ${PORTAUDIO_LIBRARY})
        endif()
    else()
        if(MSVC)
            set_source_files_properties(rtpa.c PROPERTIES LANGUAGE CXX)
            target_link_libraries(rtpa winmm dsound setupapi ${PORTAUDIO_LIBRARY} ${CSOUND_WINDOWS_LIBRARIES})
        else()
            target_link_libraries(rtpa ${PORTAUDIO_LIBRARY})
        endif()
    endif()
else()
  message(STATUS "Not building Portaudio Driver...")
  message(STATUS "Portaudio v19 Found: ${PORTAUDIO_V19}.")
endif()

if(APPLE)
    check_deps(USE_PORTMIDI PORTMIDI_INCLUDE_PATH PORTMIDI_LIBRARY)
elseif(WIN32)
  if(MSVC)
    check_deps(USE_PORTMIDI PORTMIDI_INCLUDE_PATH PORTMIDI_LIBRARY)
  else()
    if(NEED_PORTTIME)
      check_deps(USE_PORTMIDI PORTMIDI_INCLUDE_PATH PORTTIME_INCLUDE_PATH PORTMIDI_LIBRARY)
    else()
      check_deps(USE_PORTMIDI PORTMIDI_INCLUDE_PATH PORTMIDI_LIBRARY)
    endif()
  endif()
elseif(NEED_PORTTIME)
    check_deps(USE_PORTMIDI PORTMIDI_INCLUDE_PATH PORTMIDI_LIBRARY PORTTIME_LIBRARY)
else()
    check_deps(USE_PORTMIDI PORTMIDI_INCLUDE_PATH PORTMIDI_LIBRARY)
endif()

if(USE_PORTMIDI)
    make_plugin(pmidi pmidi.c)
    target_include_directories(pmidi PRIVATE ${PORTMIDI_INCLUDE_PATH})
    target_link_libraries(pmidi ${PORTMIDI_LIBRARY})
    if(LINUX)
      if(NEED_PORTTIME)
        target_include_directories(pmidi PRIVATE ${PORTTIME_INCLUDE_PATH})
        target_link_libraries(pmidi ${PORTTIME_LIBRARY})
      endif()
    elseif(WIN32)
      if(NEED_PORTTIME)
          target_include_directories(pmidi PRIVATE ${PORTTIME_INCLUDE_PATH})
      endif()
      target_link_libraries(pmidi ${CSOUND_WINDOWS_LIBRARIES})
    elseif(LINUX AND ALSA_LIBRARY)
      target_link_libraries(pmidi ${ALSA_LIBRARY})
    endif()

    add_dependency_to_framework(pmidi ${PORTMIDI_LIBRARY})
endif()

#check_deps(USE_IPMIDI PORTMIDI_HEADER PORTMIDI_LIBRARY)
if(USE_IPMIDI)
    if(WIN32)
      set(ipmidi_LIBS ws2_32)
    endif()
    make_plugin(ipmidi ipmidi.c "${ipmidi_LIBS}")
endif()

check_deps(USE_JACK JACK_HEADER JACK_LIBRARY)
if(USE_JACK)
    set(rtjack_LIBS "")
    if(LINUX)
        list(APPEND rtjack_LIBS
            ${JACK_LIBRARY} ${PTHREAD_LIBRARY})
    elseif(WIN32)
        list(APPEND rtjack_LIBS
            ${JACKDMP_LIBRARY} ${PTHREAD_LIBRARY})
    else()
        list(APPEND rtjack_LIBS
            ${JACK_LIBRARY} ${PTHREAD_LIBRARY})
    endif()
    make_plugin(rtjack rtjack.c "${rtjack_LIBS}")
endif()

check_deps(USE_FLTK FLTK_FOUND)
if(USE_FLTK)
    set(widgets_SRCS FL_graph.cpp winFLTK.c widgets.cpp)
    make_plugin(widgets "${widgets_SRCS}" "${FLTK_LIBRARIES}")
    if(NOT MSVC)
        target_link_libraries(widgets ${FLTK_BASE_LIBRARY})
        target_link_libraries(widgets ${FLTK_FORMS_LIBRARY})
        target_link_libraries(widgets ${FLTK_IMAGES_LIBRARY})
    else()
        target_link_libraries(widgets ${FLTK_LIBRARIES})
    endif()
    target_include_directories(widgets PRIVATE ${FLTK_INCLUDE_DIR})
    #add_dependency_to_framework(widgets ${FLTK_BASE_LIBRARY})
    #add_dependency_to_framework(widgets ${FLTK_FORMS_LIBRARY})
    #add_dependency_to_framework(widgets ${FLTK_IMAGES_LIBRARY})
endif()

check_deps(BUILD_VIRTUAL_KEYBOARD FLTK_FOUND)
if(BUILD_VIRTUAL_KEYBOARD)
    set(virtual_SRCS virtual_keyboard/FLTKKeyboard.cpp
        virtual_keyboard/FLTKKeyboardWindow.cpp
        virtual_keyboard/FLTKKeyboardWidget.cpp
        virtual_keyboard/virtual_keyboard.cpp
        virtual_keyboard/Bank.cpp
        virtual_keyboard/KeyboardMapping.cpp
        virtual_keyboard/Program.cpp
        virtual_keyboard/SliderBank.cpp
        virtual_keyboard/SliderData.cpp)
    make_plugin(virtual "${virtual_SRCS}" "${FLTK_LIBRARIES}")
    if (NOT MSVC)
        target_link_libraries(virtual ${FLTK_BASE_LIBRARY})
        target_link_libraries(virtual ${FLTK_FORMS_LIBRARY})
        target_link_libraries(virtual ${FLTK_IMAGES_LIBRARY})
    else()
        target_link_libraries(virtual ${FLTK_LIBRARIES})
    endif()
    #add_dependency_to_framework(virtual ${FLTK_BASE_LIBRARY})
    #add_dependency_to_framework(virtual ${FLTK_FORMS_LIBRARY})
    #add_dependency_to_framework(virtual ${FLTK_IMAGES_LIBRARY})
    target_include_directories(virtual PRIVATE ".")
    target_include_directories(virtual PRIVATE ${FLTK_INCLUDE_DIR})
endif()

message(STATUS "")

=== Opcodes/CMakeLists.txt ===
option(BUILD_CHUA_OPCODES "Build the chua opcodes" ON)
option(BUILD_DSSI_OPCODES "Build the DSSI opcodes" ON)
option(BUILD_FLUID_OPCODES "Build the fluidsynth opcodes" ON)
option(BUILD_JACK_OPCODES "Build the JACK related opcodes" OFF)
option(BUILD_LINEAR_ALGEBRA_OPCODES "Build the Linear Algebra Opcodes" ON)
option(BUILD_OSC_OPCODES "Build the OSC Opcodes" ON)
option(BUILD_IMAGE_OPCODES "Build the image opcodes" ON)
option(BUILD_PYTHON_OPCODES "Build the Python opcodes" ON)
option(BUILD_LUA_OPCODES "Build the Lua opcodes" ON)
option(BUILD_WIIMOTE_OPCODES "Build the Wiimote opcodes" ON)
option(BUILD_P5GLOVE_OPCODES "Build the P5Glove opcodes" ON)
option(BUILD_SERIAL_OPCODES "Build the serial opcode" ON)
option(BUILD_PLATEREV_OPCODES "Build the platerev opcode" ON)
option(BUILD_FAUST_OPCODES "Build the Faust opcodes" OFF)
option(BUILD_VST4CS_OPCODES "Build the vst4cs opcodes" OFF)
option(BUILD_EXCITER_OPCODES "Build the exciter opcode" ON)
option(BUILD_BUCHLA_OPCODES "Build the Buchla filter opcode" ON)
option(BUILD_PADSYNTH_OPCODES "Build the Padsynth opcode" ON)
option(BUILD_SCANSYN_OPCODES "Build the scansyn opcodes" ON)
option(BUILD_SELECT_OPCODE "Build the select opcode" ON)
option(BUILD_STACK_OPCODES "Build the stack opcodes" ON)

message(STATUS "## Building Opcodes ##")
#find_package (Eigen3 3.3 REQUIRED NO_MODULE)
include(CheckIncludeFiles)
check_include_file(ladspa.h LADSPA_H)
check_include_file(fluidsynth.h FLUIDSYNTH_H)
find_path(FLUIDSYNTH_INCLUDE_DIR "fluidsynth.h")
find_library(FLUIDSYNTH_LIBRARY fluidsynth)
find_library(JACK_LIBRARY jack)
find_library(JACKDMP_LIBRARY jackdmp)
check_include_file(jack/jack.h JACK_HEADER)
check_include_file(lo/lo.h OSC_HEADER)
find_path(OSC_HEADER_INC "lo/lo.h")
find_library(LIBLO_LIBRARY lo)
find_package(ZLIB)
find_package(PNG)
set(PYTHON_INCLUDE_DIRS /usr/include/Python2.7)
set(Python_ADDITIONAL_VERSIONS 2.7)
find_package(PythonLibs)

check_include_file(wiiuse.h WIIUSE_H)
find_library(WIIUSE_LIB wiiuse)
check_include_file(p5glove.h P5GLOVE_H)
find_library(P5GLOVE_LIB p5glove)

if(BUILD_FAUST_OPCODES)
find_package(LLVM)
exec_program(llvm-config ARGS --libs OUTPUT_VARIABLE LLVM_LIBS)
find_library(FAUST_LIBRARY libfaust.a HINTS /usr/local/lib)
endif()

## OPCODE LIBS WITH NO EXTERNAL DEPENDENCIES ##

make_plugin(mixer mixer.cpp)
make_plugin(signalflowgraph signalflowgraph.cpp)

make_plugin(ampmidid ampmidid.cpp)
make_plugin(cs_date date.c)
make_plugin(system_call system_call.c)
make_plugin(doppler doppler.cpp)
make_plugin(fractalnoise tl/fractalnoise.cpp)
make_plugin(ftsamplebank ftsamplebank.cpp)
make_plugin(getftargs getftargs.c)
make_plugin(liveconv liveconv.c)

make_plugin(fareygen fareygen.c)
make_plugin(quadbezier quadbezier.c)

if(APPLE)
   make_plugin(arrayops arrayops.cpp)
   set_target_properties(arrayops PROPERTIES COMPILE_FLAGS
   "-std=c++11")
    make_plugin(pvsops pvsops.cpp)
   set_target_properties(pvsops PROPERTIES COMPILE_FLAGS "-std=c++11")
elseif(LINUX)
    include(CheckCXXCompilerFlag)
    CHECK_CXX_COMPILER_FLAG("-std=gnu++11" COMPILER_SUPPORTS_CXX11)
     if(COMPILER_SUPPORTS_CXX11)
       make_plugin(arrayops arrayops.cpp)
       set_target_properties(arrayops PROPERTIES COMPILE_FLAGS
   "-std=gnu++11")
       make_plugin(pvsops pvsops.cpp)
      set_target_properties(pvsops PROPERTIES COMPILE_FLAGS "-std=gnu++11")
     else()
        message(STATUS "Not building array operators as no C++11 support found.")
     endif()
else()
    make_plugin(arrayops arrayops.cpp)
    make_plugin(pvsops pvsops.cpp)
    if(WIN32 AND NOT MSVC)
      set_target_properties(arrayops PROPERTIES COMPILE_FLAGS
      "-std=gnu++11")
      set_target_properties(pvsops PROPERTIES COMPILE_FLAGS "-std=gnu++11")
      endif()
endif()


if(BUILD_PADSYNTH_OPCODES)
if(APPLE)
  make_plugin(padsynth padsynth_gen.cpp)
  set_target_properties(padsynth PROPERTIES COMPILE_FLAGS "-std=gnu++11 -stdlib=libc++"
    LINK_FLAGS "-std=gnu++11 -stdlib=libc++")
elseif(LINUX)
    include(CheckCXXCompilerFlag)
    CHECK_CXX_COMPILER_FLAG("-std=gnu++11" COMPILER_SUPPORTS_CXX11)
    CHECK_CXX_COMPILER_FLAG("-std=gnu++0x" COMPILER_SUPPORTS_CXX0X)
    if(COMPILER_SUPPORTS_CXX11)
        make_plugin(padsynth padsynth_gen.cpp)
        set_target_properties(padsynth PROPERTIES COMPILE_FLAGS "-std=gnu++11")
    elseif(COMPILER_SUPPORTS_CXX0X)
        make_plugin(padsynth padsynth_gen.cpp)
        set_target_properties(padsynth PROPERTIES COMPILE_FLAGS "-std=gnu++0x")
    else()
        message(STATUS "Not building padsynth as no C++11 support found.")
    endif()
else()
    make_plugin(padsynth padsynth_gen.cpp)

    if(WIN32 AND NOT MSVC)
      set_target_properties(padsynth PROPERTIES COMPILE_FLAGS "-std=gnu++11"
        LINK_FLAGS "-std=gnu++11")
    endif()
endif()
endif()


make_plugin(cellular cellular.c)

if(BUILD_SERIAL_OPCODES)
   make_plugin(serial serial.c)
endif()

if(BUILD_PLATEREV_OPCODES)
   make_plugin(platerev platerev.c m)
endif()

if(BUILD_SCANSYN_OPCODES)
    set(scansyn_SRCS
        scansyn.c scansynx.c)
    make_plugin(scansyn "${scansyn_SRCS}" m)
endif()

if(UNIX)
    make_plugin(control control.c)
    make_plugin(urandom urandom.c)
endif()

if(LINUX)
    #make_plugin(urandom urandom.c)
    make_plugin(joystick linuxjoystick.c)
endif()

## OPCODES WITH EXTERNAL DEPENDENCIES ##

check_deps(BUILD_CHUA_OPCODES EIGEN3_INCLUDE_PATH)
if(BUILD_CHUA_OPCODES)
    make_plugin(chua chua/ChuaOscillator.cpp)
    target_include_directories(chua PRIVATE ${Boost_INCLUDE_DIRS})
endif()

check_deps(BUILD_DSSI_OPCODES LINUX)
if(BUILD_DSSI_OPCODES)
    set(dssi_SRC dssi4cs/src/load.c dssi4cs/src/dssi4cs.c)
    make_plugin(dssi4cs "${dssi_SRC}" dl)
endif()

check_deps(BUILD_FLUID_OPCODES FLUIDSYNTH_H FLUIDSYNTH_LIBRARY)
if(BUILD_FLUID_OPCODES)
    make_plugin(fluidOpcodes fluidOpcodes/fluidOpcodes.cpp)
    if(EXISTS ${FLUIDSYNTH_INCLUDE_DIR})
        target_include_directories(fluidOpcodes PRIVATE "${FLUIDSYNTH_INCLUDE_DIR}")
     endif()

     if(WIN32 AND NOT MSVC)
        set(FSYNTH_SUPPORT_LIBS dsound portaudio
          ${LIBSNDFILE_LIBRARY} ${LIBSNDFILE_SUPPORT_LIBS} wsock32 glib-2.0
          intl iconv ws2_32 winmm Setupapi)
        target_link_libraries(fluidOpcodes ${FSYNTH_SUPPORT_LIBS})

        target_compile_definitions(fluidOpcodes PRIVATE -DFLUIDSYNTH_NOT_A_DLL)
     else()
        target_link_libraries(fluidOpcodes ${FLUIDSYNTH_LIBRARY})
     endif()
     add_dependency_to_framework(fluidOpcodes ${FLUIDSYNTH_LIBRARY})
endif()

set(JACK_LIB (JACK_LIBRARY OR JACKDMP_LIBRARY))
check_deps(BUILD_JACK_OPCODES JACK_HEADER JACK_LIB)
if(BUILD_JACK_OPCODES)
    set(jack_LIBS ${PTHREAD_LIBRARY})
    if(JACKDMP_LIBRARY)
        list(APPEND jack_LIBS ${JACKDMP_LIBRARY})
    else()
        list(APPEND jack_LIBS ${JACK_LIBRARY})
    endif()
    make_plugin(jacko jacko.cpp "${jack_LIBS}")
    set_target_properties(jacko PROPERTIES COMPILE_FLAGS
   "-std=c++11")
    make_plugin(jackTransport jackTransport.c "${jack_LIBS}")
endif()

check_deps(BUILD_LINEAR_ALGEBRA_OPCODES GMM_FOUND)
if(BUILD_LINEAR_ALGEBRA_OPCODES)
    make_plugin(linear_algebra linear_algebra.cpp)
    target_include_directories(linear_algebra PRIVATE ${GMM_INCLUDE_DIRS})
    if (MSVC)
        target_compile_options(linear_algebra PRIVATE "/D_SCL_SECURE_NO_DEPRECATE")
    endif()
endif()

check_deps(BUILD_OSC_OPCODES LIBLO_LIBRARY OSC_HEADER)
if(BUILD_OSC_OPCODES)
    make_plugin(osc OSC.c)
    if(WIN32)
	  target_include_directories(osc PRIVATE ${OSC_HEADER_INC})
      target_link_libraries(osc ${LIBLO_LIBRARY})
	  # FIXME how to build a static version of this?
      if(BUILD_STATIC_LIBRARY AND NOT MSVC)
        add_library(pthread_static STATIC IMPORTED)
        set_target_properties(pthread_static PROPERTIES IMPORTED_LOCATION ${PTHREAD_LIBRARY})
        target_link_libraries(osc pthread_static)
      elseif(NOT MSVC)
        target_link_libraries(osc ${PTHREAD_LIBRARY})
      endif()
      target_link_libraries(osc wsock32 ws2_32 iphlpapi)
    else()
      target_link_libraries(osc ${LIBLO_LIBRARY} pthread)
    endif()
    add_dependency_to_framework(osc ${LIBLO_LIBRARY})
endif()

check_deps(BUILD_IMAGE_OPCODES PNG_FOUND)
if(BUILD_IMAGE_OPCODES)
    make_plugin(image imageOpcodes.c)
    target_include_directories(image PRIVATE ${PNG_INCLUDE_DIR})
    target_link_libraries(image ${PNG_LIBRARIES})
    target_compile_definitions(image PRIVATE ${PNG_DEFINITIONS})
    add_dependency_to_framework(image ${PNG_LIBRARY})
endif()

check_deps(BUILD_PYTHON_OPCODES PYTHONLIBS_FOUND)
if(BUILD_PYTHON_OPCODES)
    make_plugin(py py/pythonopcodes.c)
    target_include_directories(py PRIVATE ${PYTHON_INCLUDE_DIRS})
    target_include_directories(py PRIVATE ${CMAKE_HOME_DIRECTORY}/include)
	target_link_libraries(py ${PYTHON_LIBRARIES})
endif()

if(NOT APPLE)
  check_deps(BUILD_LUA_OPCODES LUAJIT_LIBRARY LUA_H_PATH)
  if(BUILD_LUA_OPCODES)
    make_plugin(LuaCsound LuaCsound.cpp ${LUAJIT_LIBRARY})
    target_compile_options(LuaCsound PRIVATE ${OpenMP_CXX_FLAGS})
    target_include_directories(LuaCsound PRIVATE ${LUA_H_PATH})
  endif()
endif()

check_deps(BUILD_WIIMOTE_OPCODES WIIUSE_H WIIUSE_LIB)
if(BUILD_WIIMOTE_OPCODES)
    make_plugin(wiimote wiimote.c ${WIIUSE_LIB})
    add_dependency_to_framework(wiimote ${WIIUSE_LIB})

endif()

if(BUILD_EXCITER_OPCODES)
    make_plugin(exciter exciter.c)
endif()

if(BUILD_BUCHLA_OPCODES)
    make_plugin(buchla buchla.c)
endif()

check_deps(BUILD_P5GLOVE_OPCODES P5GLOVE_H)
if(BUILD_P5GLOVE_OPCODES)
    make_plugin(p5g p5glove.c ${P5GLOVE_LIB})
endif()

if(BUILD_SELECT_OPCODE)
    make_plugin(select select.c)
endif()

if(BUILD_STACK_OPCODES)
    make_plugin(stackops stackops.c)
endif()

check_deps(BUILD_FAUST_OPCODES LLVM_FOUND FAUST_LIBRARY)
if(BUILD_FAUST_OPCODES)
  make_plugin(faustcsound faustgen.cpp)
if(APPLE)
  target_link_libraries(faustcsound -lcrypto)
  target_link_libraries(faustcsound -lcurses)
  target_link_libraries(faustcsound -lz)
else()
  target_link_libraries(faustcsound -Wl,-no-as-needed -lcrypto)
  target_link_libraries(faustcsound -Wl,-no-as-needed -lcurses)
  target_link_libraries(faustcsound -Wl,-no-as-needed -lz)
endif()
  target_link_libraries(faustcsound ${PTHREAD_LIBRARY})
  target_compile_definitions(faustcsound PRIVATE "-DFAUSTFLOAT=double")

 if(APPLE)
 if(${OSX_VERSION} STREQUAL "10.6")
    target_link_libraries(faustcsound ${FAUST_LIBRARY} -ldl -L$ENV{HOME}/lib -L/usr/local/lib ${LLVM_LIBS})
  else()
      target_compile_options(faustcsound PRIVATE "-stdlib=libc++")
     target_link_libraries(faustcsound ${FAUST_LIBRARY} -stdlib=libc++ -ldl -L$ENV{HOME}/lib -L/usr/local/lib ${LLVM_LIBS})
  endif()
  else()
    target_link_libraries(faustcsound ${FAUST_LIBRARY} -ldl -L$ENV{HOME}/lib -L/usr/local/lib ${LLVM_LIBS})
   endif()

  target_include_directories(faustcsound PRIVATE ${LLVM_INCLUDE_DIRS})
endif()


# OGG Opcode previously was built only for OLPC
#if(VORBISFILE_LIBRARY)
#    set(vorbis_LIBS ${libcsound_LIBS} ${VORBISFILE_LIBRARY})
#    make_plugin(ogg ogg.c "${vorbis_LIBS}")
#endif()

check_deps(BUILD_VST4CS_OPCODES VSTSDK2X_FOUND FLTK_FOUND)
message(STATUS "VSTSDK2X_INCLUDE_DIR: ${VSTSDK2X_INCLUDE_DIR}")
if(BUILD_VST4CS_OPCODES)
    set(VST4CS_SRCS
        vst4cs/src/vst4cs.cpp
        vst4cs/src/vsthost.cpp
        vst4cs/src/fxbank.cpp
        ${VSTSDK2X_INCLUDE_DIR}/public.sdk/source/vst2.x/audioeffect.cpp
        ${VSTSDK2X_INCLUDE_DIR}/public.sdk/source/vst2.x/audioeffectx.cpp)
    add_library(vst4cs SHARED ${VST4CS_SRCS})
    target_compile_definitions(vst4cs PRIVATE -DVST_FORCE_DEPRECATED=0 -DCS_VSTHOST)
    target_include_directories(vst4cs PRIVATE ${VSTSDK2X_INCLUDE_DIR})
    target_include_directories(vst4cs PRIVATE ${VSTSDK2X_INCLUDE_DIR}/public.sdk/source/vst2.x)
    target_include_directories(vst4cs PRIVATE ${VSTSDK2X_INCLUDE_DIR}/pluginterfaces/source/vst2.x)
    target_include_directories(vst4cs PRIVATE ${FLTK_INCLUDE_DIR})
    set_target_properties(vst4cs PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${BUILD_BIN_DIR}

=== frontends/CMakeLists.txt ===
option(BUILD_PD_CLASS "Build the puredata csoundapi~ class" ON)
option(BUILD_CSBEATS "Build the beats score frontend" ON)
option(BUILD_WINSOUND "Build the Winsound frontend. Requires FLTK headers and libs." OFF)
option(BUILD_CSOUND_VST "Build the CsoundVST frontend. Requires the Steinberg VST SDK 2.3." OFF)

if (NOT MSVC)
    find_package(FLEX)
    find_package(BISON)
endif()

find_path(PD_HEADER_PATH m_pd.h)
find_library(PD_LIBRARY pd.dll)

## Csound Commandline Executable ##
set(CS_MAIN_SRCS csound/csound_main.c)
if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    list(APPEND CS_MAIN_SRCS csound/sched.c)
    list(APPEND CSOUNDLIB -lpthread)
endif()

function(make_plugin_frontend libname srcs)
    if(APPLE)
        add_library(${libname} SHARED ${srcs})
    else()
        add_library(${libname} MODULE ${srcs})
    endif()

    set(i 2)
    while( ${i} LESS ${ARGC} )
        if(NOT MSVC OR NOT("${ARGV${i}}" MATCHES "m"))
            target_link_libraries(${libname} ${ARGV${i}})
        endif()
        math(EXPR i "${i}+1")
    endwhile()

    set_target_properties(${libname} PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR}
        LIBRARY_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR}
        ARCHIVE_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR})

    install(TARGETS ${libname}
	LIBRARY DESTINATION "${PLUGIN_INSTALL_DIR}" )
endfunction(make_plugin_frontend)


# We need a different name to avoid clashes with float libcsound
make_executable(csound-bin "${CS_MAIN_SRCS}" "${CSOUNDLIB}" csound)
if(LINUX)
  target_link_libraries(csound-bin m)
endif()

# Post build dependencies copy for MSVC
if(MSVC)
	add_custom_command(TARGET csound-bin
					   POST_BUILD
					   COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_SOURCE_DIR}/msvc/deps/bin
						$<TARGET_FILE_DIR:csound-bin>
					   COMMENT "Running copy dependencies script...")
endif()

message(STATUS "Building csLadspa.")

make_plugin_frontend(csladspa "csladspa/csladspa.cpp" "${CSOUNDLIB}")
# We do not want the lib prefix
set_target_properties(csladspa PROPERTIES PREFIX "")

# CSBeats

check_deps(BUILD_CSBEATS FLEX_EXECUTABLE BISON_EXECUTABLE)

if(BUILD_CSBEATS)
    BISON_TARGET(csbeats_PARSER beats/beats.y ${CMAKE_CURRENT_BINARY_DIR}/beats.tab.c)
    FLEX_TARGET(csbeats_SCANNER beats/beats.l ${CMAKE_CURRENT_BINARY_DIR}/beatslex.yy.c)

    ADD_FLEX_BISON_DEPENDENCY(csbeats_SCANNER csbeats_PARSER)

    set(csbeats_SRCS
    	${CMAKE_CURRENT_SOURCE_DIR}/beats/main.c
        ${FLEX_csbeats_SCANNER_OUTPUTS}
        ${BISON_csbeats_PARSER_OUTPUTS})


    if(MSVC)
        set_source_files_properties(${FLEX_csbeats_SCANNER_OUTPUTS} PROPERTIES
        COMPILE_FLAGS -DYY_NO_UNISTD_H)
      make_executable(csbeats "${csbeats_SRCS}" "")
    else()
      make_executable(csbeats "${csbeats_SRCS}" "m")
    endif()

    target_include_directories(csbeats PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
    target_include_directories(csbeats PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/beats)
endif()

#PD Interface
if(WIN32)
    check_deps(BUILD_PD_CLASS PD_HEADER_PATH PD_LIBRARY)
else()
    check_deps(BUILD_PD_CLASS PD_HEADER_PATH)
endif()
if(BUILD_PD_CLASS)
    if(LINUX)
        set(pdname "csound6~.pd_linux")
    elseif(APPLE)
        set(pdname "csound6~.pd_darwin")
    elseif(WIN32)
        set(pdname "csound6~.dll")
    endif()
    add_library(pdcsound MODULE csoundapi_tilde/csoundapi_tilde.c)
    target_include_directories(pdcsound PRIVATE ${PD_HEADER_PATH})
    if(WIN32)
        target_link_libraries (pdcsound ${CSOUNDLIB} ${PD_LIBRARY})
        set_target_properties(pdcsound  PROPERTIES "LINK_FLAGS"
            "-Wl,--allow-multiple-definition")
    else()
        target_link_libraries (pdcsound ${CSOUNDLIB})
    endif()
    set_target_properties(pdcsound PROPERTIES
        PREFIX ""
        SUFFIX ""
        OUTPUT_NAME ${pdname}
        RUNTIME_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR}
        LIBRARY_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR}
        ARCHIVE_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR})
    if(APPLE)
        set_target_properties(pdcsound  PROPERTIES "LINK_FLAGS"
            "-flat_namespace -undefined suppress")
    endif(APPLE)
    install(TARGETS pdcsound
        LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR})
endif()


#WinSound
check_deps(BUILD_WINSOUND FLTK_FOUND)
if(BUILD_WINSOUND)
    set(WINSOUND_FL ${CMAKE_CURRENT_SOURCE_DIR}/winsound/winsound.fl)
    set(WINSOUND_CXX ${CMAKE_CURRENT_BINARY_DIR}/winsound.cxx)
    set(WINSOUND_H ${CMAKE_CURRENT_BINARY_DIR}/winsound.h)
    set_source_files_properties(${WINSOUND_CXX} GENERATED)
    set_source_files_properties(${WINSOUND_H} GENERATED)

	find_program(FLUID_BIN NAMES fluid)
	if(FLUID_BIN)
		add_custom_target(winsound_fl COMMAND ${FLUID_BIN} -c -o ${WINSOUND_CXX} -h  ${WINSOUND_H} ${WINSOUND_FL})
	else()
		message(WARNING "Could not find fluid executable")
	endif()

    set(WINSOUND_SRCS ${WINSOUND_CXX} winsound/main.cxx)

    make_executable(winsound "${WINSOUND_SRCS}" "${FLTK_LIBRARIES}")
    target_link_libraries (winsound ${CSOUNDLIB})
    add_dependencies(winsound winsound_fl)
    target_include_directories(winsound PRIVATE ${FLTK_INCLUDE_DIR})
    target_include_directories(winsound PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
    target_include_directories(winsound PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/winsound)
endif()

# debugger command line app
make_executable(csdebugger debugger/csdebugger.cpp "${CSOUNDLIB}")

# icsound interactive python API
if(PYTHON_MODULE_INSTALL_DIR)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/icsound/icsound.py
            DESTINATION ${PYTHON_MODULE_INSTALL_DIR})
endif()

# Others
add_subdirectory(CsoundAC)
add_subdirectory(CsoundVST)
add_subdirectory(max_csound_tilde)

=== include/CMakeLists.txt ===
file(GLOB csheaders RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*.h")
file(GLOB csheaders_hpp RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*.hpp")
list(APPEND csheaders ${csheaders_hpp})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/float-version.h.in ${CMAKE_CURRENT_BINARY_DIR}/float-version.h)

# These don't live here... but we list them here to have all headers
# in one place
list(APPEND csheaders
    ../interfaces/CsoundFile.hpp
    ../interfaces/CppSound.hpp
    ../interfaces/filebuilding.h
    ../interfaces/csPerfThread.hpp)

set(csacheaders
    ../frontends/CsoundAC/Cell.hpp
    ../frontends/CsoundAC/ChordLindenmayer.hpp
    ../frontends/CsoundAC/Composition.hpp
    ../frontends/CsoundAC/Conversions.hpp
    ../frontends/CsoundAC/Counterpoint.hpp
    ../frontends/CsoundAC/CounterpointNode.hpp
    ../frontends/CsoundAC/Event.hpp
    ../frontends/CsoundAC/Exception.hpp
    ../frontends/CsoundAC/Hocket.hpp
    ../frontends/CsoundAC/ImageToScore.hpp
    ../frontends/CsoundAC/Lindenmayer.hpp
    ../frontends/CsoundAC/MCRM.hpp
    ../frontends/CsoundAC/Midifile.hpp
    ../frontends/CsoundAC/MusicModel.hpp
    ../frontends/CsoundAC/Node.hpp
    ../frontends/CsoundAC/OrchestraNode.hpp
    ../frontends/CsoundAC/Platform.hpp
    ../frontends/CsoundAC/Random.hpp
    ../frontends/CsoundAC/Rescale.hpp
    ../frontends/CsoundAC/Score.hpp
    ../frontends/CsoundAC/ScoreModel.hpp
    ../frontends/CsoundAC/ScoreNode.hpp
    ../frontends/CsoundAC/Sequence.hpp
    ../frontends/CsoundAC/Shell.hpp
    ../frontends/CsoundAC/Silence.hpp
    ../frontends/CsoundAC/Soundfile.hpp
    ../frontends/CsoundAC/StrangeAttractor.hpp
    ../frontends/CsoundAC/System.hpp
    ../frontends/CsoundAC/Voicelead.hpp
    ../frontends/CsoundAC/VoiceleadingNode.hpp
    )

set(csvstheaders
    frontends/CsoundVST/CsoundVstFltk.hpp
    frontends/CsoundVST/CsoundVST.hpp
    frontends/CsoundVST/CsoundVstUi.h
    frontends/CsoundVST/Platform.hpp
    frontends/CsoundVST/ScoreGenerator.hpp
    frontends/CsoundVST/ScoreGeneratorVstFltk.hpp
    frontends/CsoundVST/ScoreGeneratorVst.hpp
    frontends/CsoundVST/ScoreGeneratorVstUi.h
    )

set(csheaders ${csheaders} PARENT_SCOPE)

if(NOT APPLE)
    INSTALL(FILES ${csheaders} DESTINATION ${HEADER_INSTALL_DIR})
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/float-version.h DESTINATION ${HEADER_INSTALL_DIR})
endif()

IF( BUILD_CSOUND_AC )
    INSTALL(FILES ${csacheaders} DESTINATION ${HEADER_INSTALL_DIR})
endif()

# Enable this when we build CsoundVST
#INSTALL(FILES ${csvstheaders} DESTINATION ${HEADER_INSTALL_DIR})

=== interfaces/CMakeLists.txt ===
## Language bindings ##

# C++ INTERFACE LIBRARY

option(BUILD_CXX_INTERFACE "Build the C++ interface library" ON)
option(BUILD_PYTHON_INTERFACE "Build the Python interface (needs BUILD_CXX_INTERFACE)" ON)
option(BUILD_JAVA_INTERFACE "Build the Java interface (needs BUILD_CXX_INTERFACE)" ON)
option(BUILD_LUA_INTERFACE "Build the Lua interface (needs BUILD_CXX_INTERFACE)" ON)
find_package(SWIG)


if(BUILD_CXX_INTERFACE)
    message(STATUS "Building C++ interface library.")
    set(libcsnd6_SRCS
        CppSound.cpp
        CsoundFile.cpp
        Soundfile.cpp
        csPerfThread.cpp
        cs_glue.cpp
        filebuilding.cpp)

    add_library(libcsnd6 SHARED ${libcsnd6_SRCS})
    set(libcsnd6_LIBS ${LIBSNDFILE_LIBRARY} )

    if(WIN32)
      list(APPEND libcsnd6_LIBS "${LIBSNDFILE_SUPPORT_LIBS}")
      # mingw64 needs this to create a valid .pyd.

      if(NOT MSVC AND CMAKE_SIZEOF_VOID_P EQUAL 8)
        target_compile_definitions(libcsnd6 PRIVATE -DMS_WIN64)
      endif()
    endif()

    set(libcsnd6_CFLAGS "")
    list(APPEND libcsnd6_LIBS ${CSOUNDLIB})

    target_link_libraries(libcsnd6 ${libcsnd6_LIBS})
    # users of this lib will need this dir included
    target_include_directories(libcsnd6 INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})
    set_target_properties(libcsnd6 PROPERTIES
        SOVERSION ${APIVERSION}
        OUTPUT_NAME csnd6
        RUNTIME_OUTPUT_DIRECTORY ${BUILD_BIN_DIR}
        LIBRARY_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
        ARCHIVE_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
        )

   if(APPLE)
    target_compile_options(libcsnd6 PRIVATE "-std=c++11")
   endif()


    if(${libcsnd6_CFLAGS})
        target_compile_options(libcsnd6 PRIVATE ${libcsnd6_CFLAGS})
    endif()



    install(TARGETS libcsnd6
        LIBRARY DESTINATION "${LIBRARY_INSTALL_DIR}"
        ARCHIVE DESTINATION "${LIBRARY_INSTALL_DIR}")
else()
 message(STATUS "NOT Building C++ interface library.")
endif()




# SWIG INTERFACES
find_package(SWIG 2.0)
find_package(PythonLibs)
find_package(JNI)
find_package(Java)

find_library(LUAJIT_LIBRARY luajit)
if(NOT LUAJIT_LIBRARY)
    find_library(LUAJIT_LIBRARY luajit-5.1)
endif()
if(NOT LUAJIT_LIBRARY AND WIN32)
    find_library(LUAJIT_LIBRARY lua51)
endif()
find_path(LUA_H_PATH lua.h PATH_SUFFIXES luajit-2.0)

message(STATUS "PYTHON_LIBRARY: " ${PYTHON_LIBRARY})

check_deps(BUILD_PYTHON_INTERFACE SWIG_FOUND BUILD_CXX_INTERFACE PYTHONLIBS_FOUND)
check_deps(BUILD_JAVA_INTERFACE SWIG_FOUND BUILD_CXX_INTERFACE JNI_FOUND JAVA_FOUND)
check_deps(BUILD_LUA_INTERFACE SWIG_FOUND BUILD_CXX_INTERFACE  LUAJIT_LIBRARY LUA_H_PATH)

if(BUILD_PYTHON_INTERFACE OR BUILD_JAVA_INTERFACE OR BUILD_LUA_INTERFACE)
    message(STATUS "SWIG_USE_FILE: " ${SWIG_USE_FILE})
    include(${SWIG_USE_FILE})
    set(CMAKE_SWIG_FLAGS ${libcsound_CFLAGS})
    list(APPEND CMAKE_SWIG_FLAGS "-includeall" "-verbose")
    if(USE_DOUBLE)
        list(APPEND CMAKE_SWIG_FLAGS "-DUSE_DOUBLE")
    endif(USE_DOUBLE)
    set(CMAKE_SWIG_OUTDIR ${BUILD_LIB_DIR})
    if(BUILD_PYTHON_INTERFACE)
        if(WIN32)
            set(swigpython_LIBS ${CSOUNDLIB} ${LIBSNDFILE_LIBRARY} ${LIBSNDFILE_SUPPORT_LIBS} ${PYTHON_LIBRARY} libcsnd6)
        else()
            # Note: Do not link to PYTHON_LIBRARY so that it can be loaded in any python
            set(swigpython_LIBS ${CSOUNDLIB} ${LIBSNDFILE_LIBRARY} libcsnd6)
        endif()
        SET_SOURCE_FILES_PROPERTIES(python_interface.i
            PROPERTIES CPLUSPLUS ON
            SWIG_MODULE_NAME csnd6)
        set(SWIG_MODULE_csnd6_EXTRA_DEPS ../include/csound.h ../include/cfgvar.h ../include/csound.hpp
                                        cs_glue.hpp csPerfThread.hpp CsoundFile.hpp
                                        CppSound.hpp filebuilding.h Soundfile.hpp)
		swig_add_module(csnd6 python python_interface.i)
        swig_link_libraries(csnd6 ${swigpython_LIBS})
        target_include_directories(${SWIG_MODULE_csnd6_REAL_NAME} PRIVATE ${PYTHON_INCLUDE_PATH})
        set_target_properties(${SWIG_MODULE_csnd6_REAL_NAME} PROPERTIES
            RUNTIME_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            LIBRARY_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            ARCHIVE_OUTPUT_DIRECTORY ${BUILD_LIB_DIR})
	if(APPLE)
	    set_target_properties(${SWIG_MODULE_csnd6_REAL_NAME} PROPERTIES
                LINK_FLAGS "-undefined dynamic_lookup")
	endif()

        install(TARGETS ${SWIG_MODULE_csnd6_REAL_NAME}
            LIBRARY DESTINATION "${PYTHON_MODULE_INSTALL_DIR}"
            ARCHIVE DESTINATION "${PYTHON_MODULE_INSTALL_DIR}")
        install(FILES ${BUILD_LIB_DIR}/csnd6.py
            DESTINATION ${PYTHON_MODULE_INSTALL_DIR})
        install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/ctcsound.py
            DESTINATION ${PYTHON_MODULE_INSTALL_DIR})

    endif()

    if(BUILD_JAVA_INTERFACE)
        # The java package needs this unset or it will litter us with .java files
        unset(CMAKE_SWIG_OUTDIR)

       message(STATUS "JNI INCLUDE set to ${JNI_INCLUDE_DIRS}.")

      	if(WIN32)
             set(swigjava_LIBS ${JNI_LIBRARIES} ${CSOUNDLIB}
               ${LIBSNDFILE_LIBRARY} ${LIBSNDFILE_SUPPORT_LIBS} libcsnd6)
        elseif(APPLE)
             set(swigjava_LIBS  ${JAVA_VM_LIBRARY} ${CSOUNDLIB}
	             ${LIBSNDFILE_LIBRARY} libcsnd6)
        else()
             set(swigjava_LIBS ${CSOUNDLIB} ${LIBSNDFILE_LIBRARY} libcsnd6)
        endif()

        list(APPEND javaSwigOptions -package csnd6 -includeall)
        SET_SOURCE_FILES_PROPERTIES(java_interface.i PROPERTIES CPLUSPLUS ON)
        SET_SOURCE_FILES_PROPERTIES(java_interface.i PROPERTIES SWIG_FLAGS "${javaSwigOptions}")

        set(SWIG_MODULE__jcsound6_EXTRA_DEPS ../include/csound.h ../include/cfgvar.h ../include/csound.hpp
                                        cs_glue.hpp csPerfThread.hpp CsoundFile.hpp
                                        CppSound.hpp filebuilding.h Soundfile.hpp)

        SWIG_ADD_MODULE(_jcsound6 java java_interface.i)
        SWIG_LINK_LIBRARIES(_jcsound6 ${swigjava_LIBS})
        target_include_directories(${SWIG_MODULE__jcsound6_REAL_NAME} PRIVATE ${JNI_INCLUDE_DIRS})

        ADD_CUSTOM_COMMAND(TARGET _jcsound6
            POST_BUILD
            COMMAND cmake -E make_directory ./csnd6
            COMMAND ${JAVA_COMPILE} *.java -source 1.6 -target 1.6 -d .
            COMMAND ${JAVA_ARCHIVE} cf ../csnd6.jar csnd6
            COMMENT "Building JAVA package csnd6.jar")

        set_target_properties(_jcsound6 PROPERTIES
            RUNTIME_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            LIBRARY_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            ARCHIVE_OUTPUT_DIRECTORY ${BUILD_LIB_DIR})

        install(TARGETS _jcsound6
            LIBRARY DESTINATION "${JAVA_MODULE_INSTALL_DIR}"
            ARCHIVE DESTINATION "${JAVA_MODULE_INSTALL_DIR}")
        install(FILES ${BUILD_LIB_DIR}/csnd6.jar
            DESTINATION ${JAVA_MODULE_INSTALL_DIR})

    endif()

    if(BUILD_LUA_INTERFACE)
        set(swiglua_LIBS ${LUAJIT_LIBRARY} ${CSOUNDLIB} libcsnd6)

        SET_SOURCE_FILES_PROPERTIES(lua_interface.i
            PROPERTIES CPLUSPLUS ON
            SWIG_MODULE_NAME luaCsnd6)


        set(SWIG_MODULE_luaCsnd6_EXTRA_DEPS ../include/csound.h ../include/cfgvar.h ../include/csound.hpp
                                        cs_glue.hpp csPerfThread.hpp CsoundFile.hpp
                                        CppSound.hpp filebuilding.h Soundfile.hpp)

        SWIG_ADD_MODULE(luaCsnd6 lua lua_interface.i)
        SWIG_LINK_LIBRARIES(luaCsnd6 ${swiglua_LIBS})

        target_include_directories(${SWIG_MODULE_luaCsnd6_REAL_NAME} PRIVATE ${LUA_H_PATH})

      	if(APPLE)
            set_target_properties(${SWIG_MODULE_luaCsnd6_REAL_NAME} PROPERTIES
                LINK_FLAGS "-undefined dynamic_lookup")
      	endif()

        set_target_properties(${SWIG_MODULE_luaCsnd6_REAL_NAME} PROPERTIES
            RUNTIME_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            LIBRARY_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            ARCHIVE_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            PREFIX "")

        install(TARGETS luaCsnd6
            LIBRARY DESTINATION "${LUA_MODULE_INSTALL_DIR}"
            ARCHIVE DESTINATION "${LUA_MODULE_INSTALL_DIR}")

    endif()

endif()

=== util/CMakeLists.txt ===
# UTILITY PLUGIN AND PROGRAMS

set(stdutil_SRCS
    atsa.c          cvanal.c        dnoise.c    envext.c
    het_export.c    het_import.c    hetro.c     lpanal.c
    lpc_export.c    lpc_import.c    mixer.c     pvanal.c
    pv_export.c     pv_import.c     pvlook.c    scale.c
    sndinfo.c       srconv.c        std_util.c  xtrct.c
    ../SDIF/sdif.c)

if(MSVC) 
  make_plugin(stdutil "${stdutil_SRCS}" )
  target_link_libraries(stdutil ${LIBSNDFILE_LIBRARY} ${LIBSNDFILE_SUPPORT_LIBS})
elseif(WIN32)
  make_plugin(stdutil "${stdutil_SRCS}" m
    ${LIBSNDFILE_LIBRARY} ${LIBSNDFILE_SUPPORT_LIBS})
else()
  make_plugin(stdutil "${stdutil_SRCS}" m ${LIBSNDFILE_LIBRARY})
endif()

add_dependency_to_framework(stdutil ${LIBSNDFILE_LIBRARY})

if(BUILD_UTILITIES)
    make_utility(atsa        atsa_main.c)
    make_utility(csanalyze   csanalyze.c)
    make_utility(cvanal      cvl_main.c)
    make_utility(dnoise      dnoise_main.c)
    make_utility(envext      env_main.c)
    make_utility(extractor   xtrc_main.c)
    make_utility(het_export  hetx_main.c)
    make_utility(het_import  heti_main.c)
    make_utility(hetro       het_main.c)
    make_utility(lpanal      lpc_main.c)
    make_utility(lpc_export  lpcx_main.c)
    make_utility(lpc_import  lpci_main.c)
    make_executable(mixer-bin   mixer_main.c   "${CSOUNDLIB}" mixer)
    if(LINUX)
      target_link_libraries(mixer-bin m)
    endif()
    make_utility(pvanal      pvc_main.c)
    make_utility(pvlook      pvl_main.c)
    make_utility(pv_export   pvx_main.c)
    make_utility(pv_import   pvi_main.c)
    make_utility(scale       scale_main.c)
    make_utility(sndinfo     sndinfo_main.c)
    make_utility(srconv      srconv_main.c)


    find_library(LIBSNDFILE_LIBRARY sndfile libsndfile-1)
    find_library(LIBSAMPLERATE_LIBRARY samplerate)

    if(LIBSNDFILE_LIBRARY AND LIBSAMPLERATE_LIBRARY)
        make_executable(src_conv new_srconv.c "${LIBSNDFILE_LIBRARY};${LIBSAMPLERATE_LIBRARY}")
    else()
        message(STATUS "Not building src_conv (libsndfile or libsamplerate not found).")
    endif()

endif()

=== Opcodes/emugens/CMakeLists.txt ===
option(BUILD_EMUGENS_OPCODES "Build emugens opcodes" ON)

if(BUILD_EMUGENS_OPCODES)
  # set(SOURCES emugens.c scugens.c)
  make_plugin(scugens scugens.c)
  make_plugin(emugens emugens.c)
endif()

=== Opcodes/framebuffer/CMakeLists.txt ===
option(BUILD_FRAMEBUFFER_OPCODES "Build the framebuffer opcodes" ON)


if(BUILD_FRAMEBUFFER_OPCODES)


	set(SOURCES Framebuffer.c OLABuffer.c OpcodeEntries.c)
 	make_plugin(framebuffer "${SOURCES}")

endif()

=== Opcodes/stk/CMakeLists.txt ===
option(BUILD_STK_OPCODES "Build the stk opcodes" ON)

if(WIN32)
    cmake_policy(SET CMP0060 NEW)
endif()

if(NOT STK_LOCAL)
    find_package(STK)
endif()

if(BUILD_STK_OPCODES)
    if(DEFAULT_STK_RAWWAVE_PATH)
        set(rawwave_path "-DDEFAULT_RAWWAVE_PATH=\\\"${DEFAULT_STK_RAWWAVE_PATH}\\\"")
    endif()
    #find_library(STK_LIBRARY stk)
    if(STK_LIBRARY)
        find_path(STK_INCLUDE_DIR Stk.h
            /usr/include/stk
            /usr/local/include/stk)
        check_deps(BUILD_STK_OPCODES STK_INCLUDE_DIR)
        if(STK_INCLUDE_DIR)
            make_plugin(stkops stkOpcodes.cpp)
            target_include_directories(stkops PRIVATE ${STK_INCLUDE_DIR})
            message(STATUS "Building STK opcodes.")
            if(BUILD_STATIC_LIBRARY)
                if(WIN32)
                    add_library(stk STATIC IMPORTED)
                    set_target_properties(stk PROPERTIES IMPORTED_LOCATION ${STK_LIBRARY})
                    target_link_libraries(stkops stk)
                else()
                    target_link_libraries(stkops ${STK_LIBRARY})
                endif()
            else()
              target_link_libraries(stkops ${STK_LIBRARIES})
              target_link_libraries(stkops ${PTHREAD_LIBRARY})
            endif()
            target_compile_definitions(stkops PRIVATE ${rawwave_path})
        endif()
    else()
        set(stk_remove_srcs
            src/InetWvIn.cpp    src/InetWvOut.cpp
            src/Mutex.cpp       src/RtAudio.cpp
            src/RtMidi.cpp      src/Messager.cpp
            src/RtWvIn.cpp      src/RtWvOut.cpp
            src/Socket.cpp      src/TcpClient.cpp
            src/TcpServer.cpp   src/Thread.cpp
            src/UdpSocket.cpp)
        file(GLOB stk_srcs RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} src/*)
        list(REMOVE_ITEM stk_srcs ${stk_remove_srcs})
        list(APPEND stk_srcs stkOpcodes.cpp)
        # Assume that if this file exists, then we have the sources
        find_file(STK_FOUND
            NAMES src/InetWvIn.cpp
            HINTS ${CMAKE_CURRENT_SOURCE_DIR})
        find_path(STK_INCLUDE_DIR Stk.h ./include)
        check_deps(BUILD_STK_OPCODES STK_FOUND STK_INCLUDE_DIR)
        if(BUILD_STK_OPCODES)
            make_plugin(stkops "${stk_srcs}")
            target_include_directories(stkops PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include)
            target_include_directories(stkops PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include/stk)
            target_include_directories(stkops PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/src)
            set(stkdefs "-D__STK_REALTIME__")
            if(APPLE)
                list(APPEND stkdefs "-D__OS_MACOSX__")
                list(REMOVE_ITEM stkdefs "-D__STK_REALTIME__")
            elseif(LINUX)
                list(APPEND stkdefs "-D__OS_LINUX__")
                list(APPEND stkdefs "-D__LINUX_ALSA__")
            elseif(WIN32)
                list(APPEND stkdefs "-D__OS_WINDOWS__")
            endif()
            if(BIG_ENDIAN)
                list(APPEND stkdefs "-D__BIG_ENDIAN__")
            else()
                list(APPEND stkdefs "-D__LITTLE_ENDIAN__")
            endif()
            target_compile_definitions(stkops PRIVATE ${stkdefs})
            target_compile_definitions(stkops PRIVATE ${rawwave_path})
        endif()
    endif()
endif()

=== Opcodes/websockets/CMakeLists.txt ===
option(BUILD_WEBSOCKET_OPCODE "Build the websocket opcode" ON)
FIND_PATH ( WEBSOCKETS_H libwebsockets.h
    /usr/local/include
    /usr/include
)

if(WIN32 AND NOT MSVC) 
  find_library (websockets_library NAMES websockets_static)
else()
  FIND_LIBRARY ( websockets_library websockets
      /usr/local/lib
      /usr/lib
  )
  find_library (websockets_library NAMES websockets)

if(APPLE)
FIND_LIBRARY (ssl_library NAMES ssl.a
      /usr/local/lib
      /usr/lib
  )
   #find_library (crypto_library NAMES crypto.a
   FIND_LIBRARY ( crypto_library NAMES crypto.a
      /usr/local/lib
      /usr/lib
  )
   #find_library (crypto_library NAMES crypto)
endif()

endif()

check_include_file(libwebsockets.h WEBSOCKETS_H)

if(WEBSOCKETS_H AND websockets_library) 
  set(CMAKE_REQUIRED_INCLUDES libwebsockets.h)
  set(CMAKE_REQUIRED_LIBRARIES ${websockets_library})
endif()

check_deps(BUILD_WEBSOCKET_OPCODE websockets_library)
if(BUILD_WEBSOCKET_OPCODE)

 	make_plugin(websocketIO WebSocketOpcode.c)
 	target_link_libraries(websocketIO ${websockets_library} ${CSOUNDLIB})

  if(APPLE)
   target_link_libraries(websocketIO /usr/local/lib/libssl.a /usr/local/lib/libcrypto.a  z)
  endif()
  
  if(WIN32 AND NOT MSVC) 
    target_link_libraries(websocketIO ssl crypto z ws2_32 wsock32)
  endif()
endif()

=== frontends/CsoundAC/CMakeLists.txt ===
# Build CsoundAC

include(CheckIncludeFiles)

set(CMAKE_CXX_STANDARD 11)

option(BUILD_CSOUND_AC "Build CsoundAC extension module for Csound with algorithmic composition (needs C++ interface)" ON)
option(BUILD_CSOUND_AC_PYTHON_INTERFACE "Build the Csound AC Python interface" ON)
option(BUILD_CSOUND_AC_LUA_INTERFACE "Build the Csound AC Lua interface" ON)
option(USE_SYSTEM_PORTSMF ON)

find_library(MUSICXML_LIBRARY musicxml2)
find_package(FLTK)
find_package(Eigen3 NO_MODULE)
find_package(SWIG)
find_package(PythonLibs)
find_library(PORTSMF_LIBRARY portSMF)
find_library(LUAJIT_LIBRARY luajit)
find_library(JPEG_LIBRARY jpeg)
find_library(PNG_LIBRARY NAMES png png16 libpng16)
find_library(Z_LIBRARY NAMES z zlib)

if(NOT LUAJIT_LIBRARY)
    find_library(LUAJIT_LIBRARY luajit-5.1)
endif()
if(NOT LUAJIT_LIBRARY AND WIN32)
    find_library(LUAJIT_LIBRARY lua51)
endif()
find_path(LUA_H_PATH lua.h PATH_SUFFIXES luajit-2.0)

check_deps(BUILD_CSOUND_AC BUILD_CXX_INTERFACE FLTK_FOUND LIBSNDFILE_LIBRARY Eigen3_FOUND EIGEN3_INCLUDE_PATH)
check_deps(BUILD_CSOUND_AC_PYTHON_INTERFACE SWIG_FOUND PYTHONLIBS_FOUND BUILD_CSOUND_AC)
check_deps(BUILD_CSOUND_AC_LUA_INTERFACE SWIG_FOUND LUAJIT_LIBRARY BUILD_CSOUND_AC)

if(BUILD_CSOUND_AC)
    set(libcsoundac_SRCS
	    Cell.cpp
	    ChordLindenmayer.cpp
	    Composition.cpp
	    Conversions.cpp
	    Counterpoint.cpp
	    CounterpointMain.cpp
	    CounterpointNode.cpp
	    Event.cpp
	    Hocket.cpp
	    ImageToScore.cpp
	    Lindenmayer.cpp
	    MCRM.cpp
	    Midifile.cpp
	    MusicModel.cpp
	    Node.cpp
	    Random.cpp
	    Rescale.cpp
	    Score.cpp
	    ScoreModel.cpp
	    ScoreNode.cpp
	    Sequence.cpp
	    Shell.cpp
	    Soundfile.cpp
	    StrangeAttractor.cpp
	    System.cpp
	    Voicelead.cpp
	    VoiceleadingNode.cpp)

    check_deps(USE_SYSTEM_PORTSMF PORTSMF_LIBRARY)
    if(NOT USE_SYSTEM_PORTSMF)
        list(APPEND libcsoundac_SRCS
            allegro.cpp
            allegrord.cpp
            allegroserial.cpp
            allegrosmfrd.cpp
            allegrosmfwr.cpp
            allegrowr.cpp
            mfmidi.cpp
            strparse.cpp
            trace.cpp)
    endif()

    if (MSVC)
        add_library(libCsoundAC STATIC ${libcsoundac_SRCS})
    else()
        add_library(libCsoundAC SHARED ${libcsoundac_SRCS})
    endif()

    target_include_directories(libCsoundAC PRIVATE ${EIGEN3_INCLUDE_PATH})
    target_include_directories(libCsoundAC PRIVATE ${FLTK_INCLUDE_DIR})

    set_target_properties(libCsoundAC PROPERTIES
        SOVERSION ${APIVERSION}
        OUTPUT_NAME CsoundAC
        RUNTIME_OUTPUT_DIRECTORY ${BUILD_BIN_DIR}
        LIBRARY_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
        ARCHIVE_OUTPUT_DIRECTORY ${BUILD_LIB_DIR})

    target_link_libraries(libCsoundAC PRIVATE libcsnd6 ${CSOUNDLIB} ${FLTK_LIBRARIES} ${LIBSNDFILE_LIBRARY})
    if(USE_SYSTEM_PORTSMF)
        target_link_libraries(libCsoundAC PRIVATE ${PORTSMF_LIBRARY})
    endif()

    if(WIN32) # for MSYS2/mingw64
        #  mingw64 needs this to create a valid .pyd.
        if(NOT MSVC AND CMAKE_SIZEOF_VOID_P EQUAL 8)
            target_compile_definitions(libCsoundAC PRIVATE -DMS_WIN64)
        endif()
        target_link_libraries(libCsoundAC PRIVATE ${JPEG_LIBRARY} ${PNG_LIBRARY} ${Z_LIBRARY})
    endif()

    if(HAVE_UNISTD_H)
      set_target_properties(libCsoundAC PROPERTIES
        COMPILE_FLAGS "-DHAVE_UNISTD_H")
    endif()

    if(MUSICXML_LIBRARY)
        target_link_libraries(libCsoundAC PRIVATE libcsnd6 ${CSOUNDLIB} ${FLTK_LIBRARIES} ${LIBSNDFILE_LIBRARY} ${MUSICXML_LIBRARY})
    endif()

    install(TARGETS libCsoundAC
        LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}
        ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR})

    if(SWIG_FOUND)
        message(STATUS "SWIG_USE_FILE: " ${SWIG_USE_FILE})
        include(${SWIG_USE_FILE})
        set(CMAKE_SWIG_OUTDIR ${BUILD_LIB_DIR})
        include_directories(${CMAKE_CURRENT_SOURCE_DIR})
	    list(APPEND CMAKE_SWIG_FLAGS "-includeall" "-verbose")
    endif()

    if(BUILD_CSOUND_AC_PYTHON_INTERFACE)
        message(STATUS "Building CsoundAC Python interface.")
        find_package(PythonLibs)
        include_directories(${PYTHON_INCLUDE_PATH})
        # Had: 	    SWIG_FLAGS "-threads"
        set_source_files_properties(CsoundAC.i
            PROPERTIES CPLUSPLUS ON
            SWIG_MODULE_NAME CsoundAC)

        swig_add_module(CsoundAC python CsoundAC.i)
        swig_link_libraries(CsoundAC libCsoundAC libcsnd6 ${CSOUNDLIB} ${FLTK_LIBRARIES} ${LIBSNDFILE_LIBRARY} ${PYTHON_LIBRARIES})

        if(MUSICXML_LIBRARY)
            swig_link_libraries(CsoundAC libCsoundAC libcsnd6 ${CSOUNDLIB} ${FLTK_LIBRARIES} ${LIBSNDFILE_LIBRARY} ${MUSICXML_LIBRARY} ${PYTHON_LIBRARIES})
        endif()

  	    if(APPLE)
            set_target_properties(${SWIG_MODULE_CsoundAC_REAL_NAME} PROPERTIES
                LINK_FLAGS "-undefined dynamic_lookup")
       	endif()

        set_target_properties(${SWIG_MODULE_CsoundAC_REAL_NAME} PROPERTIES
            RUNTIME_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            LIBRARY_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            ARCHIVE_OUTPUT_DIRECTORY ${BUILD_LIB_DIR})

        install(TARGETS ${SWIG_MODULE_CsoundAC_REAL_NAME}
            LIBRARY DESTINATION "${PYTHON_MODULE_INSTALL_DIR}"
            ARCHIVE DESTINATION "${PYTHON_MODULE_INSTALL_DIR}")
        install(FILES ${BUILD_LIB_DIR}/CsoundAC.py
            DESTINATION ${PYTHON_MODULE_INSTALL_DIR})
    endif()

    if(BUILD_CSOUND_AC_LUA_INTERFACE)
        message(STATUS "Building CsoundAC Lua interface.")

        SET_SOURCE_FILES_PROPERTIES(luaCsoundAC.i
            PROPERTIES CPLUSPLUS ON
            SWIG_MODULE_NAME luaCsoundAC)
        SWIG_ADD_MODULE(luaCsoundAC lua luaCsoundAC.i)
        SWIG_LINK_LIBRARIES(luaCsoundAC libCsoundAC libcsnd6 ${CSOUNDLIB} ${FLTK_LIBRARIES} ${LIBSNDFILE_LIBRARY} ${LUAJIT_LIBRARY})

        if(MUSICXML_LIBRARY)
          SWIG_LINK_LIBRARIES(luaCsoundAC libCsoundAC libcsnd6 ${CSOUNDLIB} ${FLTK_LIBRARIES} ${LIBSNDFILE_LIBRARY} ${MUSICXML_LIBRARY} ${LUAJIT_LIBRARY})
        endif()

  	    if(APPLE)
            set_target_properties(${SWIG_MODULE_luaCsoundAC_REAL_NAME} PROPERTIES
                LINK_FLAGS "-undefined dynamic_lookup")
       	endif()
        target_include_directories(${SWIG_MODULE_luaCsoundAC_REAL_NAME} PRIVATE ${LUA_H_PATH})

        set_target_properties(${SWIG_MODULE_luaCsoundAC_REAL_NAME} PROPERTIES
            RUNTIME_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            LIBRARY_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            ARCHIVE_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            PREFIX "")

        install(TARGETS luaCsoundAC
            LIBRARY DESTINATION "${LUA_MODULE_INSTALL_DIR}"
            ARCHIVE DESTINATION "${LUA_MODULE_INSTALL_DIR}")
    endif()

endif()

=== debian/changelog ===
csound (1:6.10.0~dfsg-2) unstable; urgency=medium

  * Change Vcs-* to point to salsa
  * Change maintainer address to debian-multimedia@lists.debian.org
  * Use debhelper cmake+ninja buildsystem instead of using half meson, half
    cmake.
    This requires debhelper 11.2.1 so bump the dependency accordingly
  * Fix patch message encoding
  * Pick upstream patch to fix crash in the orc parser (Closes: #896872)
  * ctcsound: import the SOVERSIONed library.
    Otherwise we need the dev packages installed (Closes: #896872)
  * Add some basic autopkgtests to the python modules
  * Make python destroy the created global csound object.
    Otherwise we get a crash. (Closes: #896326)

 -- Felipe Sateler <fsateler@debian.org>  Wed, 25 Apr 2018 16:32:13 -0300

csound (1:6.10.0~dfsg-1) unstable; urgency=medium

  * Use SOURCE_DATE_EPOCH envvar instead of parsing the changelog
  * Use the ninja cmake backend for some build speed
  * Bump debhelper compat level to 10
  * New upstream version
    - Refresh patches
    - Add new symbols
  * Force loading of plugins in build dir and not system ones
  * Pass DEFAULT_STK_RAWWAVE_PATH via cmake flags instead of custom.cmake.
    Fixes some quoting issues
  * Use add_compile_options instead of add_compiler_flags.
    The latter no longer exists
  * Backport patches from upstream to enable -Werror=format-security

 -- Felipe Sateler <fsateler@debian.org>  Fri, 26 Jan 2018 21:25:56 -0300

=== debian/control ===
Source: csound
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Felipe Sateler <fsateler@debian.org>,
           Forrest Cahoon <forrest.cahoon@gmail.com>
Section: sound
Priority: optional
Build-Depends: debhelper (>= 11.2.1),
               dh-buildinfo,
               dh-linktree,
               python,
               devscripts,
               cmake,
               ninja-build,
               libsndfile1-dev,
               libasound2-dev [linux-any],
               libjack-dev,
               portaudio19-dev,
               libportmidi-dev,
               libpulse-dev,
               swig,
               liblua5.1-0-dev,
               python-dev,
               puredata-dev,
               default-jdk,
               libsamplerate0-dev,
               libfltk1.1-dev,
               libfluidsynth-dev,
               liblo-dev,
               fluid,
               ladspa-sdk,
               libpng-dev,
               dssi-dev,
               libstk0-dev,
               libgmm++-dev (>= 4.2.1~beta1~svn4635~dfsg-4),
               bison,
               flex,
               libportsmf-dev,
               libeigen3-dev,
               dh-python,
               libcunit1-dev
Build-Depends-Indep: doxygen,
                     graphviz,
                     libjs-jquery,
                     ttf-dejavu
Standards-Version: 4.0.1
Vcs-Browser: https://salsa.debian.org/multimedia-team/csound
Vcs-Git: https://salsa.debian.org/multimedia-team/csound.git
Homepage: https://csound.github.io/

Package: csound
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: csound-utils
Description: powerful and versatile sound synthesis software
 Csound is a sound and music synthesis system. Drawing from over 450
 signal processing modules, it can be used to model virtually any
 synthesizer or multi-effect processor. It can work either in real-time
 or as a compiler.
 .
 Csound is to sound synthesis as C is to programming.

Package: csound-data
Architecture: all
Depends: ${misc:Depends}
Description: data files used by the csound library
 This package includes the architecture-independent data files used by
 the csound library or plugins.
 .
 For more information on Csound see the csound package.

Package: csound-utils
Architecture: any
Depends: csound,
         ${misc:Depends},
         ${shlibs:Depends}
Description: miscellaneous utilities for the Csound system
 This package contains several utilities which may be useful with
 Csound.
 These utilities aid in score creation, sound analysis and sound
 transformations.

Package: libcsound64-6.0
Architecture: any
Section: libs
Depends: csound-data,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: csound,
            stk
Description: main library for Csound
 This package contains the library which provides most of the Csound
 functionality. This library was built using 64-bit precision for the
 calculations (this doesn't mean you need a 64-bit processor).
 .
 For more information on Csound, see the csound package.

Package: libcsnd6-java
Architecture: any
Section: java
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: csound
Suggests: java-virtual-machine
Description: Java bindings for the Csound API
 These are the java bindings for the Csound API.
 .
 For more information on Csound, see the csound package

Package: libcsound64-dev
Architecture: all
Section: libdevel
Depends: libcsound64-6.0 (<< ${source:Version}.1~),
         libcsound64-6.0 (>= ${source:Version}),
         ${misc:Depends}
Description: development files for Csound
 This package contains the development files needed to build programs
 linking to the Csound library.
 .
 For more information on Csound, see the csound package.

Package: libcsnd-dev
Architecture: all
Section: libdevel
Depends: libcsnd6-6.0v5 (<< ${source:Version}.1~),
         libcsnd6-6.0v5 (>= ${source:Version}),
         libcsound64-dev,
         ${misc:Depends}
Suggests: liblua5.1-luacsnd
Provides: liblua5.1-luacsnd-dev
Description: development files for Csound -- C++ API
 This package contains the development files needed to build programs
 using the C++ bindings to the Csound library. It also includes the
 development symlink for the lua module, but you have to manually
 install liblua5.1-luacsnd for that to work.
 .
 For more information on Csound, see the csound package.

Package: libcsoundac-dev
Architecture: all
Section: libdevel
Depends: libcsoundac6.0v5 (<< ${source:Version}.1~),
         libcsoundac6.0v5 (>= ${source:Version}),
         ${misc:Depends}
Description: development files for CsoundAC
 This package contains the development files needed to build programs
 using the CsoundAC algorithmic composition system.
 .
 For more information on Csound and CsoundAC, see the csound and
 csoundac packages.

Package: pd-csound
Architecture: any
Depends: csound,
         puredata | pd,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Csound external for PureData
 This is the csound6~ opcode for PureData.
 .
 For more information on Csound or pureData, see the respective
 packages.

Package: python-csound
Architecture: any
Section: python
Depends: ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Recommends: python-matplotlib,
            python-numpy
Provides: ${python:Provides}
Description: Python bindings for Csound
 This is the Python binding for the Csound API.
 .
 It also contains the icsound and ctcsound modules (these need
 matplotlib and numpy).
 .
 For more information on Csound, see the csound package.

Package: libcsnd6-6.0v5
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: libcsnd6-6.0
Replaces: libcsnd6-6.0
Description: C++ bindings for the Csound API
 This is the C++ binding for the Csound API.
 .
 For more information on Csound, see the csound package.

Package: liblua5.1-luacsnd
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Lua bindings for the Csound API
 This is the Lua binding for the Csound API.
 .
 For more information on Csound, see the csound package.

Package: libcsoundac6.0v5
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: libcsoundac6.0
Replaces: libcsoundac6.0
Description: Csound Algorithmic Composition library
 This is the core library for CsoundAC. It provides all the CsoundAC
 functionality. It also contains the development files to create C++
 programs.
 .
 For more information on Csound, see the csound package.

Package: python-csoundac
Architecture: any
Section: python
Depends: python-csound,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Provides: ${python:Provides}
Description: Python bindings for CsoundAC
 This is the Python interface to the Csound Algorithmic Composition
 library.
 .
 For more information on Csound, see the csound package.

Package: csladspa
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Provides: ladspa-plugin
Description: LADSPA plugin for Csound
 This plugin enables the creation of LADSPA plugins with the Csound
 language.
 .
 For more information on Csound or LADSPA, see the csound or ladspa-sdk
 packages, respectively.

Package: libcsound64-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Recommends: csound,
            libcsound64-dev
Description: Csound API documentation
 This package contains the API documentation for the Csound library in
 HTML format.
 .
 For more information on Csound, see the csound package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2007-2009 Felipe Sateler <fsateler@gmail.com>
# Copyright © 2008-2010 Jonas Smedegaard <dr@jones.dk>
# Description: Main Debian packaging script for CSound
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Csound has many format errors, so disable that. Fix pending upstream
# https://github.com/csound/csound/pull/880
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# Core options of csound
DEB_CMAKE_EXTRA_FLAGS = \
	-DBUILD_RELEASE=ON \
	-DFAIL_MISSING=ON \
	-DUSE_DOUBLE=ON \
	-DUSE_GETTEXT=ON \
	-DUSE_GIT_COMMIT=OFF \
	-DBUILD_STATIC_LIBRARY=ON \
	-DUSE_LRINT=ON \
	-DBUILD_UTILITIES=ON \
	-DNEW_PARSER_DEBUG=OFF \
	-DREQUIRE_PTHREADS=ON \
	-DBUILD_MULTI_CORE=ON \
	-DBUILD_TESTS=ON \
	-DUSE_COMPILER_OPTIMIZATIONS=OFF \
	-DPYTHON_MODULE_INSTALL_DIR=/usr/lib/python2.7/dist-packages \
	-DJAVA_MODULE_INSTALL_DIR=/usr/lib \
	-DLUA_MODULE_INSTALL_DIR=/usr/lib/lua/5.1/ \

ifneq "$(filter amd64 i386, $(DEB_HOST_ARCH_CPU))" ""
	DEB_CMAKE_EXTRA_FLAGS += -DUSE_ATOMIC_BUILTIN=ON
else
	DEB_CMAKE_EXTRA_FLAGS += -DUSE_ATOMIC_BUILTIN=OFF
endif

# I/O plugins
DEB_CMAKE_EXTRA_FLAGS += \
	-DUSE_PULSEAUDIO=ON \
	-DUSE_PORTAUDIO=ON \
	-DUSE_PORTMIDI=ON \
	-DUSE_COREMIDI=OFF \
	-DUSE_AUDIOUNIT=OFF \
	-DUSE_JACK=ON
ifeq "$(DEB_HOST_ARCH_OS)" "linux"
	DEB_CMAKE_EXTRA_FLAGS += -DUSE_ALSA=ON
else
	DEB_CMAKE_EXTRA_FLAGS += -DUSE_ALSA=OFF
endif

# Optional opcodes
DEB_CMAKE_EXTRA_FLAGS += \
	-DUSE_FLTK=ON \
	-DBUILD_STK_OPCODES=ON \
	-DDEFAULT_STK_RAWWAVE_PATH=/usr/share/stk/rawwaves \
	-DBUILD_VIRTUAL_KEYBOARD=ON \
	-DBUILD_DSSI_OPCODES=ON \
	-DBUILD_CHUA_OPCODES=ON \
	-DBUILD_DSSI_OPCODES=ON \
	-DBUILD_FLUID_OPCODES=ON \
	-DBUILD_JACK_OPCODES=ON \
	-DBUILD_LINEAR_ALGEBRA_OPCODES=ON \
	-DBUILD_OSC_OPCODES=ON \
	-DBUILD_IMAGE_OPCODES=ON \
	-DBUILD_PYTHON_OPCODES=ON \
	-DBUILD_LUA_OPCODES=ON \
	-DBUILD_PD_CLASS=ON \
	-DBUILD_WIIMOTE_OPCODES=OFF \
	-DBUILD_P5GLOVE_OPCODES=OFF \
	-DUSE_CURL=OFF \
	-DBUILD_VST4CS_OPCODES=OFF \
	-DBUILD_FAUST_OPCODES=OFF \
	-DBUILD_CUDA_OPCODES=OFF \
	-DBUILD_OPENCL_OPCODES=OFF \
	-DBUILD_EXCITER_OPCODES=ON \
	-DBUILD_BUCHLA_OPCODES=ON \
	-DBUILD_PADSYNTH_OPCODES=ON \
	-DBUILD_HDF5_OPCODES=OFF \
	-DBUILD_SCANSYN_OPCODES=OFF \
	-DBUILD_FRAMEBUFFER_OPCODES=ON \
	-DBUILD_WEBSOCKET_OPCODE=OFF \
	-DBUILD_SELECT_OPCODE=ON \
	-DBUILD_STACK_OPCODES=ON \
	-DBUILD_ABLETON_LINK_OPCODES=OFF \
	-DBUILD_EMUGENS_OPCODES=ON


# Language Wrappers
# TODO: build for all Python versions (not only current default one)
# Force build of only the default one
DEB_CMAKE_EXTRA_FLAGS += \
	-DBUILD_CXX_INTERFACE=ON \
	-DBUILD_PYTHON_INTERFACE=ON \
	-DBUILD_JAVA_INTERFACE=ON \
	-DBUILD_LUA_INTERFACE=ON \

# Frontends
DEB_CMAKE_EXTRA_FLAGS += \
	-DBUILD_CSBEATS=ON \
	-DUSE_SYSTEM_PORTSMF=ON \
	-DBUILD_MAX_CSOUND_TILDE=OFF \
	-DBUILD_CSOUND_AC=ON \
	-DBUILD_CSOUND_AC_PYTHON_INTERFACE=ON \
	-DBUILD_CSOUND_AC_LUA_INTERFACE=ON


# This is a huge optimization boost
ifneq "$(filter amd64 i386, $(DEB_HOST_ARCH_CPU))" ""
	MTUNE = ON
endif
ifneq "$(filter amd64, $(DEB_HOST_ARCH_CPU))" ""
	ENABLE_SIMD = 1
else
	ENABLE_SIMD = 0
endif

BUILDDIR=obj-$(DEB_HOST_MULTIARCH)

%:
	dh $@ --with python2,linktree,buildinfo --parallel --buildsystem=cmake+ninja --builddirectory=$(BUILDDIR)

PACKAGE_DATE = $(shell env --ignore-environment TZ=UTC LANG=C date -d@$(SOURCE_DATE_EPOCH) +%F)
PYVERSION = $(shell pyversions -vd)
PYLIBPATH2 = lib/python$(PYVERSION)/dist-packages

override_dh_auto_configure:
	sed -e 's,@PYLIBPATH@,$(PYLIBPATH2),' -e 's,@MTUNE@,$(MTUNE),' \
		-e 's,@ENABLE_SIMD@,$(ENABLE_SIMD),' \
		-e 's,@DATE@,$(PACKAGE_DATE),' -e 's,@PYVERSION@,$(PYVERSION),' \
		debian/Custom.cmake > \
		Custom.cmake
	dh_auto_configure -- $(DEB_CMAKE_EXTRA_FLAGS)

override_dh_auto_build-arch:
	dh_auto_build

override_dh_auto_build-indep:
	# we need this to install headers
	dh_auto_build
	mkdir -p doc/doxygen
	cd doc && doxygen
	rm doc/doxygen/csound/html/*.md5 \
		doc/doxygen/csound/html/*.map

override_dh_auto_test:
	OPCODE6DIR64=$(BUILDDIR) dh_auto_test

override_dh_auto_clean:
	dh_auto_clean
	rm -f Custom.cmake
	rm -rf doc/doxygen
	rm -f tests/c/debug.orc tests/c/debug.sco
	rm -f tests/c/*.wav

override_dh_auto_install: override_dh_auto_install-indep override_dh_auto_install-arch

do_dh_auto_install:
	dh_auto_install
	# don't install the static library
	rm $(CURDIR)/debian/tmp/usr/lib/libcsound64.a

override_dh_auto_install-indep: do_dh_auto_install
	mkdir -p $(CURDIR)/debian/tmp/usr/share/csound/hrtf
	cp samples/*.dat $(CURDIR)/debian/tmp/usr/share/csound/hrtf

override_dh_auto_install-arch: do_dh_auto_install
	mv $(CURDIR)/debian/tmp/usr/bin/extract \
		$(CURDIR)/debian/tmp/usr/bin/csound_extract
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/pd/extra
	mv $(CURDIR)/debian/tmp/usr/lib/csound6~.pd_linux \
		$(CURDIR)/debian/tmp/usr/lib/pd/extra
	mkdir -p $(CURDIR)/debian/tmp/usr/share/java
	mv $(CURDIR)/debian/tmp/usr/lib/csnd6.jar \
		$(CURDIR)/debian/tmp/usr/share/java/csnd6-$(DEB_VERSION_UPSTREAM).jar
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/jni
	mv $(CURDIR)/debian/tmp/usr/lib/lib_jcsound6.so \
		$(CURDIR)/debian/tmp/usr/lib/jni
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/ladspa
	mv $(CURDIR)/debian/tmp/usr/lib/csound/*/csladspa.so \
		$(CURDIR)/debian/tmp/usr/lib/ladspa/csladspa.so

override_dh_installdocs:
	dh_installdocs
	dh_installdocs -A README.md AUTHORS

override_dh_missing:
	dh_missing --fail-missing

override_dh_installexamples-arch:
	dh_installexamples
	find debian/*/usr/share/doc/*/examples -type f -executable -print0 \
		| xargs -0 chmod -v a-x

override_dh_shlibdeps:
	dh_shlibdeps
	find debian/pd-csound -name '*.pd_linux' -exec dpkg-shlibdeps \
		-T$(CURDIR)/debian/pd-csound.substvars '{}' ';'

override_dh_strip:
	dh_strip
	find debian/pd-csound -name '*.pd_linux' -execdir strip \
		--remove-section=.comment --remove-section=.note --strip-unneeded '{}' ';'

override_dh_python2:
	dh_python2 -V$(PYVERSION)

=== debian/tests/control ===
Tests: python-csound
Depends: python-csound, python-all, python-numpy, python-matplotlib

Tests: python-csoundac
Depends: python-csoundac, python-all
Restrictions: allow-stderr
